﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;

namespace EventsRandomizator
{
    public class EventsRandomizator : GameComponent
    {
        private Dictionary<IncidentDef, float> chances = new Dictionary<IncidentDef, float>();

        public EventsRandomizator()
        {

        }

        public EventsRandomizator(Game game)
        {

        }

        public override void StartedNewGame()
        {
            IEnumerable<IncidentDef> incidents = DefDatabase<IncidentDef>.AllDefs;

            foreach(var incident in incidents)
            {
                float newChance = Rand.Range(1, 100);

                incident.baseChance = newChance;

                chances.Add(incident, newChance);
            }
        }

        public override void LoadedGame()
        {
            OverrideChances();
        }

        private void OverrideChances()
        {
            foreach(var incident in chances)
            {
                incident.Key.baseChance = incident.Value;
            }
        }

        public override void ExposeData()
        {
            base.ExposeData();

            Scribe_Collections.Look(ref chances, "chances", LookMode.Def, LookMode.Value);
        }
    }
}
